'FFSubmenu=Exif
'FFName=Restore Exif
' restoreExif.vbs
'*********************************************************
' RestoreExif v1.1
' Restauration von verlorenen Exif-Daten aus Originalbildern
' (C) Zaph 09/2003
' Email: zaphl@gmx.de
'
' ablauffhig ab Fixfoto V2.71 B:18
' Fixfoto: http://www.j-k-s.com
'*********************************************************
' RestoreExif importiert in die ausgewhlten Bildern
' komplette Exifblcke, falls die Exifdaten (z.B. durch
' externe Bearbeitung) nicht mehr vorliegen.
' Die zu importierenden Exifblcke werden den gleichnamigen
' Originaldateien entnommen, die die Exifdaten noch haben.
' Es werden nur Bilder ohne Exifdaten bearbeitet, Bilder mit
' Exifdaten werden bersprungen.
'
' Anwendung:
' 1. zu bearbeitende Bilder markieren
' 2. Script restoreExif.vbs starten
' 3. Verzeichnis mit den Originalbildern auswhlen
' -> Exifblcke weren importiert.
'
' nderungen:
' V1.1: Bug in Versionsabfrage gefixt

option explicit
Call Main

sub Main
	dim i,j
	dim imagenum
	dim name
	dim orgPath
	dim iNoExif
	dim iRestExif
	dim dirc, file, ext, orgFile, fileExif
	dim fso, repFile, SF, WshShell
	dim showRep

	' Version checken
	if not CheckBuild("2.71.18") then
		msgbox "Dieses Script luft erst ab FF Version 2.71 B:18 - Abbruch!", vbCritical, "RestoreExif"
		exit sub
	end if

	imagenum = FF_GetImageCount
	if imagenum = 0 then
		msgbox "Keine Bilder ausgewhlt - Abbruch!", vbCritical, "RestoreExif"
		exit sub
	end if

	orgPath = FF_EnterPath(false, "Verzeichnis mit Originalbilder zum Abgleich angeben")
	if orgpath = "" then exit sub

	repFile = FF_GetFFPath() & "RestoreExif.txt"
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set SF = fso.CreateTextFile(repFile, True)

	iNoExif = 0
	iRestExif = 0
	for i=0 to imagenum-1
		FF_SetProgress i, imagenum-1
		name = FF_GetImageName(i)
		FF_LoadExif name
		if not FF_HasExif() then
			iNoExif = iNoExif + 1
			Call SplitPath(name, dirc, file, ext)
			orgFile = orgPath & "\" & file & ext
			if fileExists(orgFile) then
				FF_LoadExif orgFile
				if FF_HasExif() then
					FF_SaveExif name
					iRestExif = iRestExif + 1
					SF.WriteLine name & " * Exif aus Originaldatei importiert"
				else
					SF.WriteLine name & " ! kein Exif - Originaldatei ebenfalls ohne Exif!"
				end if
			else
				SF.WriteLine name & " ! kein Exif - Originaldatei nicht gefunden!"
			end if
		else
			SF.WriteLine name & " * Exif vorhanden"
		end if
	next
	SF.Close
	set fso = nothing

	showRep = msgbox(imagenum & " Bild(er) untersucht." & vbcr & _
		iNoExif & " Bild(er) ohne Exif-Block." & vbcr & _
		iRestExif & " Exif-Blcke restauriert." & vbcr & vbcr & _
		"Report anzeigen?", vbInformation + vbYesNo, "RestoreExif")

	if showRep = vbYes then
		Set WshShell = CreateObject("WScript.Shell")
		WshShell.Run "%windir%\notepad " & repFile
		set WshShell = nothing
	end if

end sub

'*********************************************************
' checkt die aktuelle Version gegen eine minimal geforderte
' Version
' In:
' refBuild: Major.Minor.Build
' z.B.: "2.71.31"
' Out:
' CheckBuild: true oder false
'*********************************************************
function CheckBuild(refBuild)
	dim refver, aktver(2), i
	refver = split(refBuild,".",-1)
	for i=0 to 2
		refver(i) = cint(refver(i))
	next
	On Error Resume Next
	aktver(0) = FF_GetMajor()
	if err.number then
		CheckBuild = false
		exit function
	end if
	On Error goto 0
	aktver(1) = FF_GetMinor()
	aktver(2) = FF_GetBuild()
	if aktver(0) > refver(0) then
		CheckBuild = true
		exit function
	elseif aktver(0) = refver(0) then
		if aktver(1) > refver(1) then
			CheckBuild = true
			exit function
		elseif aktver(1) = refver(1) then
			if aktver(2) >= refver(2) then
				CheckBuild = true
				exit function
			end if
		else
			CheckBuild = false
			exit function
		end if
	else
		CheckBuild = false
		exit function
	end if
end function

'*********************************************************
' liefert Verzeichnis mit abschliessendem Backslash,
' Dateinamen und Erweiterung mit einleitendem Punkt
'*********************************************************
sub SplitPath(path, byref dirc, byref file, byref ext)
	dim fso
	Set fso = CreateObject("Scripting.FileSystemObject")
	dirc = fso.GetParentFolderName(path) & "\"
	file = fso.GetBaseName(path)
	ext = "." & fso.GetExtensionName(path)
	set fso = nothing
End Sub

'*********************************************************
' checkt, ob eine Datei existiert
'*********************************************************
function fileExists(path)
	Dim fso
	Set fso = CreateObject("Scripting.FileSystemObject")
	fileExists = fso.FileExists(path)
	Set fso = nothing
end function
